<?php
/*
 * organize.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */


/*  This page is used to modify the file hierarchy, download the PO files,
 *  delete the PO file contents from database and change the language 
 *  of a PO file.
 *
 *								AUTHOR: Khader Abbeb N
 */

//starting the session
include ("include/header_info.php");

//checking for authorized user from session values
($_SESSION['user_role'] == "administrator") 
    or exit("<h2>Unauthorized Access!!!</h2><br /><hr>You are trying to access " .
            "restricted content. Your access has been logged.<br />If you have " .
            "reached this page by mistake, kindly close this window.<br /><br /> ".
            "<pre>Administrator</pre>");

include ('include/functions_common.php');
include_once ('include/functions_stat.php');
include ('include/functions_organize.php');

$file_list      = $_POST["file_list"];
$source_branch  = $_POST["source_branch"];
$dest_branch    = $_POST["dest_branch"];
$lang           = $_POST["lang"];
$overwrite      = $_POST["overwrite"];
$overwrite      = ($overwrite) ? 1 : 0;

$user           = $_SESSION['user'];
$user           = ($user) ? $user : "guest"; //else part won't occur

$root           = 1;
if($_GET["root"])
    $root 	= $_GET["root"];

$db		= dbConnect();

if ($_POST["move_file"])
{
    $ret_val = changeParent($file_list, $dest_branch, $overwrite);
    if(!$ret_val) {
        $status_msg = $error_msg;
    }
    else {
        $path = array_merge(getPath($dest_branch),getNodeName($dest_branch));
        $status_msg = "Selected files were moved under the branch " . implode("/",$path);
    }
}
else if ($_POST["change_lang"])
{
    $ret_val = changeLanguage($file_list, $lang);
    if(!$ret_val) {
        $status_msg = $error_msg;
    }
    else {
        $status_msg = "Selected files were moved under the language of code $lang";
    }
}
else if($_POST["download_branch"])
{
    $branch_id = $source_branch;
    $branch_name = getNodeName($branch_id);
    $ret_val = fn_make_child_pofiles($branch_id,$branch_name,"$dir"."temp_download/$user",
                                     false);        
    if(!$ret_val) {
        $status_msg = $error_msg;
    }
    else {
        $file_name = fn_compress($branch_name,"$dir"."temp_download/$user",".tar.gz");
        fn_delete_file($branch_name,"$dir"."temp_download/$user");
        fn_download($file_name,$file_name,"$dir"."temp_download/$user");
    }
}
else if($_POST["download_po"])
{
    $len      = count($file_list);
    if($len == 1) {
        $ret_val = fn_make_pofile($file_list[0],"$dir"."temp_download/$user",true);
    }
    else {
        $ret_val = fn_make_pofile_list($file_list,"$dir"."temp_download/$user");
    }

    if(!$ret_val) {
        $status_msg = $error_msg;
    }
    else {
        if($len == 1) {
            $temp_file = $ret_val;
            $file_name = substr($temp_file,0,strrpos($temp_file,"_"));
        }
        else {
            $file_name = fn_compress($ret_val,"$dir"."temp_download/$user",".tar.gz");
            $temp_file = $file_name;
            fn_delete_file($ret_val,"$dir"."temp_download/$user");
        }
        fn_download($file_name,$temp_file,"$dir"."temp_download/$user");
    }
}
else if($_POST["delete_file_contents"])
{
    $ret_val    = fn_delete_file_contents($file_list);
    $status_msg = $ret_val;
    
    if(!$ret_val) {
        $status_msg = $error_msg;
    }
}

include ("head.php");

?>

<script type="text/javascript" src="scripts/organize.js"> </script>
<script type="text/javascript" src="scripts/common.js"> </script>
<style type="text/css">
<!--
.tablesmall {
    border: 1pt solid #ADB9CC;
}
.tdbottom {
    background: #EEEEEE;
    padding: 5px;
}
.buttonbar li{
    float: left;
}
-->
</style>


<?php
include("body.php");
?>
   <ul id="navibar">
	<li class="wikilink"><a href="main.php">Home</a></li>
	<li class="wikilink"><a href="list.php?category=untrans&amp;page=1">Untranslated Strings</a></li>
	<li class="current" ><a href="organize.php">Organize File Hierarchy</a></li>
	<li class="wikilink"><a href="help.php">Help</a></li>
   </ul>

<div id="pageline"><hr style="display:none;"></div>
</div> 			<!-- End of Div started in "body.php" -->


<div id="page">		<!-- This DIV is optional. It provides better padding for your page -->

    <div id="drophelp" class="drophelpdiv"></div>

    <div class="msg">
        <span style="float:left">
            <?php echo $status_msg; ?>
        </span>
    </div>
    
    <ul class="buttonbar" style="clear:none">
        <li class="buttonlink">
            <a href="dbadminister.php">Database Administration</a>
        </li>
    </ul>

    <br/>
    <form name="organize_form" method="POST" action="" onSubmit="return fn_verify();">
    <table class="tablesmall" border=0 >
        <tr>
            <td colspan="3" class="tdbottom">
                <div id="sub_title">Organize File(s)</div>
            </td>
        </tr>
	    <tr>
		    <td>View Files Under</td>
		    <td>
		        <select name="source_branch" class="submit_sel" onChange="changeParent();">
			    <?php
                $list_dir = getBranchList();
                $num_dir = count ($list_dir);
                if ($num_dir)
                {
                    $list_dir = orderBy($list_dir,"path");
				    for ($i=0; $i<$num_dir; $i++)
			    	{
                        $dir_id   = $list_dir[$i]["id"];
                        $dir_path = $list_dir[$i]["path"];
                        $selected = "";
				        if ($root == $dir_id)
				    	$selected = "selected";
			    	    echo "<option value='$dir_id' $selected>$dir_path</option>";
		    		}
	    		}
    			?>
		        </select>
		        <small><a href="#" 
		        onMouseOver="changetext(content[2]);cssdropdown.dropit(this,event,'drophelp');">
		        Help</a></small>
		    </td>
            <td><input type="submit" name="download_branch" class="submit" 
                                value="Download Branch" onClick="fn_download_branch()">                                  
                <small>
                <a href="#" 
                onMouseOver="changetext(content[9]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
	    </tr>
        <tr>
            <td colspan="3">
        	    <div class="fbox">
        	    <?php insertBox($root); ?>
            	</div>
            </td>
        </tr>
	    <tr>
            <td>Destination Branch</td>
            <td >
                <select name="dest_branch" class="submit_sel">
                <?php
                    if ($num_dir)
                    {
                        for ($i=0; $i<$num_dir; $i++)
                        {
                            $dir_id   = $list_dir[$i]["id"];
                            $dir_path = $list_dir[$i]["path"];
                            echo "<option value='$dir_id'>$dir_path</option>";
                        }
                    }
                ?>
                </select>
            </td>
            <td rowspan=2>
		      <input type="submit" name="move_file" value="Move" class="smallbutton"
                                onClick="fn_move_po();">                                  
		      <small><a href="#" 
		      onMouseOver="changetext(content[3]);cssdropdown.dropit(this,event,'drophelp');">
		      Help</a></small>
            </td>
	    </tr>
        <tr>
            <td>Overwrite, if file exists</td>
            <td><input type="checkbox" name="overwrite"></td>
	    </tr>
        <tr>
            <td colspan=3></td>
        </tr>
        <tr>
            <td>Language</td>
            <td><select name="lang" class="submit_sel" onChange="changeLang();">
                <option value=''>&lt;select language&gt;</option>
                <?php
                    $lang_list = getAllLang();
                    foreach ($lang_list as $lang_ele)
                    {
                        $code     = $lang_ele["code"];
                        $language = $lang_ele["language"];
                        $selected = "";
                        if($lang == $code) {
                            $selected = 'selected';
                        }
                        echo "<option value='$code' $selected>$language</option>";
                    }
                ?>
                </select>
                <small>
                <a href="#" 
                onMouseOver="changetext(content[4]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
            <td>
                <input type="submit" name="change_lang" value="Change" class="smallbutton"
                                            onClick="fn_change();">
                <small>
                <a href="#" 
                onMouseOver="changetext(content[5]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
        <tr>
            <td colspan=3></td>
        </tr>
        <tr>
            <td><input type="submit" name="download_po" class="submit" 
                            value="Download Files" onClick="fn_download_po();">                                  
                <small>
                <a href="#" 
                onMouseOver="changetext(content[7]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
            <td><input type="submit" name="delete_file_contents" 
                            class="submit" value="Delete Files" 
                            onClick="fn_delete_file_contents()">
                <small>
                <a href="#" 
                onMouseOver="changetext(content[8]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
	</table>
    </form>
</div>			<!-- End of <div id="page"> -->
<?php
mysql_close ($db);
include("footer.php");
?>
